;Most of my programs/games are just helping me learn. so dont expect much :) im learning alot from making this!

	include "doorsos.h"			; general ROM calls
	include "graphlib.h"			; clr_scr function	
	include "userlib.h"			; idle_loop
	xdef	_main				; define program entry point
	xdef	_comment			; define program comment	
	xdef	_ti89				; compile for TI-89
	xdef	_exit
;
mask0 equ %11111110  			;(up\2nd\donw...)
mask1 equ %11111101  			;(Enter\clear...)
mask2 equ %11111011  			;( <- )
mask3 equ %11110111  			;(catalog...)
mask4 equ %11101111  			;(Mode...)
mask5 equ %11011111 				;(Home...)
mask6 equ %10111111  			;(ESC...)

DrawSpr	Macro				;macro i made for putting sprites
	move.w  \1,d0				;use "DrawSpr #,#,sprite name" to draw it at x,y
	move.w  \2,d1
	move.l  #\3,a0
	jsr     graphlib::put_sprite
	ENDM

delay:						;loop to delay the game, so it doesnt go to fast.
	move.w  #0,d0

delay_repeat:
    add.w   #1,d0
    cmp     delay_len,d0			;delay_len is speed, higher the number, the slower the game goes
    bne     delay_repeat
    rts

_main:						;start of program
	jsr		graphlib::clr_scr	;clears the screen

keyloop:
	bra		getkey			;goto getkey
nextloop:
	bsr		delay			;goto delay (delays the program for amount of time)
	bra		keyloop		;go back to mainloop

getkey:
        move.w 		#mask0,d0	;move key mask 0 into d0 (keys 2nd, left, right, up, down, etc.)
        bsr 		get_key		;goes to get_key, which will put the key that was pushed into d0
        btst.b 		#0,d0		;test to see if up was pressed
        beq		keyup		;up was pressed, goto keyup, else goto next line
        btst.b		#2,d0		;test to see if down was pressed
        beq 		keydown		;down was pressed, goto keydown, else goto next line
        btst.b		#1,d0		;check left
        beq 		keyleft		;left pressed
        btst.b 		#3,d0		;check right
        beq 		keyright	;right pressed
        btst.b 		#4,d0		;check 2nd
        beq 		key2nd		;2nd pressed
        move.b 		#mask6,d0	;put key mask 6 into d0, thats the esc key mask
	 bsr		get_key
        btst.b 		#0,d0		;check esc.
        beq 		_exit		;esc pressed, else goto next line
endgetkey:
        bra 		nextloop				;go back to mainloop


get_key:
	move.b  d0,($600019)		;keypad located at $600019 (wr) $60001b (re).
        move.w #50,d0			;give 89 time to store key press, about 50 loops
delay_c:
	dbra d0,delay_c			;loop 50 times
        move.b $60001b,d0		;gives bit stored into d0 i.e. bit 1-7
	rts

keyup:						;put instructions for when user presses up

	bra		endgetkey

keydown:						;put instructions for when user presses down

	bra		endgetkey

keyleft:						;put instructions for when user presses left

	bra		endgetkey

keyright:						;put instructions for when user presses right

	bra		endgetkey

key2nd:						;put instructions for when user presses 2nd

	bra		endgetkey

_exit:
	rts					; end of program



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; variable declaration section

_comment	dc.b	"comment",0	; program comment
delay_len	dc.w	10000				;delay (game speed) lower number = faster speed



	end					; end of the source code